﻿(function () {

    "use strict";

    angular.module("enrServicesModule")
           .factory("regionPropertiesParser", [function () {
               return {
                   getRegionPrimaryId: function (geometryObjProperties, removeLeadingZeroes, includeStateFipsPrefix) {
                       var primaryId = "";
                       
                       // For Counties, use FIPS code.
                       if (geometryObjProperties.COUNTYFP !== undefined)
                           primaryId = geometryObjProperties.COUNTYFP;

                       // For US Congressional districts, use FIPS code.
                       else if (geometryObjProperties.CD114FP !== undefined)
                           primaryId = geometryObjProperties.CD114FP;

                       // For everything else (State Senate and House Districts) just use the region name (which should simply be a district number).
                       else if (geometryObjProperties.NAME !== undefined)
                           primaryId = geometryObjProperties.NAME;

                       if (removeLeadingZeroes)
                           primaryId = Number(primaryId).toString();

                       if (includeStateFipsPrefix && geometryObjProperties.STATEFP !== undefined)
                           primaryId = geometryObjProperties.STATEFP + primaryId;

                       return primaryId;
                   },

                   getRegionDisplayName: function (geometryObjProperties) {
                       // Most region types have a Name property we can use...
                       var displayName = geometryObjProperties.NAME;

                       // ...however US congressional districts do not. Use their FIPS code since it corresponds to their district number.
                       if (displayName === undefined)
                           displayName = geometryObjProperties.CD114FP;

                       return displayName;
                   }
               };
           }]);

}());